package slova;

/**
 * Hlavn program. Vytvo instanci analuztoru a stust metoidu bh()
 */
public class Program 
{
    public static void main(String[] args) 
    {
        Analyztor analyztor = new Analyztor();// Vytvo instanci analyztoru
        analyztor.bh();                        // a spus bh programu
    }
}

/**
 * Vkonn tda programu. Pete vstup, dozlo ho na slova, 
 * zpracuje je a vype vsledky
 */
class Analyztor
{
    java.util.ArrayList<String> slovnk = new java.util.ArrayList<String>();
    String oddlovae = " .,;!?";
    
    /**
    * Tato metoda zajiuje bh programu
    */
    void bh() 
    {
       java.util.Scanner vstup = new java.util.Scanner(System.in, "Cp852");

       while(vstup.hasNextLine())                 // ti vstup
       {
           String dka = vstup.nextLine();
           dka = dka.trim();                  // Odstra okrajov mezery
           analyzujAUloVsledky(dka);
       }
       System.out.println(slovnk);               // Vypi vsledek
    }
    
    /**
    * Tato metoda rozlo dku na slova
    * @param dka analyzovan dka;
    * @param slovnk   kontejner, do kterho budou ukldna slova
    */
    private void analyzujAUloVsledky(String dka)
    {
        if(dka.equals(""))return;             // Przdn dek ns nezajm
        int index = 0;                          // Index znaku v dku
        StringBuffer slovo = null;              // Sem ulome zskan slovo
        index = peskoOddlovae(dka, index);// Najdi zatek dalho slova
        while(index >= 0)                       // Dokud nejsme na konci dku
        {
            slovo = new StringBuffer("");
            // Penes nsledujc slovo do instance "slovo"
            while((index < dka.length()) &&
                  (oddlovae.indexOf(dka.charAt(index))==-1))
            {
                slovo.append(dka.charAt(index++));
            }
            // Ulo slovo do slovnku
            String s = new String(slovo);
            if(slovnk.indexOf(s)==-1)slovnk.add(s);
            index = peskoOddlovae(dka, index);
      }
  }
    
    /**
    * Tato metoda pesko oddlovae v analyzovanm textu.
    * @param dka analyzovan dek;
    * @param od    index, od kterho se m zat
    * @return      index, kde zan nsledujc slovo, nebo -1, jsme-li na konci dku
    */
    private int peskoOddlovae(String dka, int od)
     {
        if(od >= dka.length()) return -1;          // Jsme-li na konci dku, vra -1
        while(oddlovae.indexOf(dka.charAt(od))>=0)
        {
            if(++od == dka.length()) return -1;
        }
        return od;
     }
}