﻿package konvertor;

import java.io.*;

public class Program 
{
    public static void main(String[] args) 
    {
        
        try(PrintWriter výstup = new PrintWriter(System.out))
        {
            int číslo = Integer.parseInt(args[0]);
            int základ = Integer.parseInt(args[1]);
            výstup.println(new konvertor.Konvertor(základ).konverze(číslo));
        }
        catch(ArrayIndexOutOfBoundsException e)
        {
            System.err.println("Při volání je třeba zadat dva parametry");
        }
        catch(NumberFormatException e)
        {
            System.err.println("Jeden z parametrů není číslo " + e.getMessage());
        }
        catch(konvertor.WrongBaseException e)
        {
            System.err.println("Základ soustavy " + e.getMessage() + " leží mimo interval 2 - 36");
        }
        catch(Exception e)
        {
            System.err.println("Nějaká divná chyba: " + e.getMessage());
        }
        finally
        {
            System.err.println("Použití:\n"+
                "java konvertor.Program číslo cílová_soustava\n"+
                "cílová soustava musí být v rozmezí 2 - 36");
            System.err.println("Ferda Mravenec, práce všeho druhu");
        }
    }
    
}
