package slova;

import java.io.UnsupportedEncodingException;

/**
 * Hlavn program. Vytvo instanci analuztoru a stust metoidu bh()
 */
public class Program 
{
    public static void main(String[] args) throws UnsupportedEncodingException 
    {
        Analyztor analyztor;
        if(args.length == 1)
        {
            analyztor = new Analyztor(args[0]);
        }
        else
            analyztor = new Analyztor();// Vytvo instanci analyztoru
        analyztor.bh();                        // a spus bh programu
    }
}

/**
 * Vkonn tda programu. Pete vstup, dozlo ho na slova, 
 * zpracuje je a vype vsledky
 */
class Analyztor
{
    private final java.util.ArrayList<String> slovnk = new java.util.ArrayList<>();
    private final String oddlovae = " .,;!?";
    private String kdovn = "Cp852";
    
    /**
    * Tato metoda zajiuje bh programu
    */
    void bh() throws UnsupportedEncodingException 
    {
       java.util.Scanner vstup = new java.util.Scanner(System.in, kdovn);
       java.io.OutputStreamWriter osw = new java.io.OutputStreamWriter(System.out, kdovn);
       java.io.PrintWriter vstup = new java.io.PrintWriter(osw);

       while(vstup.hasNextLine())                 // ti vstup
       {
           String dka = vstup.nextLine();
           dka = dka.trim();                  // Odstra okrajov mezery
           analyzujAUloVsledky(dka);
       }
       vstup.println(slovnk);               // Vypi vsledek
       vstup.close();
    }
    
    /**
    * Tato metoda rozlo dku na slova
    * @param dka analyzovan dka;
    * @param slovnk   kontejner, do kterho budou ukldna slova
    */
    private void analyzujAUloVsledky(String dka)
    {
        if(dka.equals(""))return;             // Przdn dek ns nezajm
        int index = 0;                          // Index znaku v dku
        StringBuffer slovo;                     // Sem ulome zskan slovo
        index = peskoOddlovae(dka, index);// Najdi zatek dalho slova
        while(index >= 0)                       // Dokud nejsme na konci dku
        {
            slovo = new StringBuffer("");
            // Penes nsledujc slovo do instance "slovo"
            while((index < dka.length()) &&
                  (oddlovae.indexOf(dka.charAt(index))==-1))
            {
                slovo.append(dka.charAt(index++));
            }
            // Ulo slovo do slovnku
            String s = new String(slovo);
            if(slovnk.indexOf(s)==-1)slovnk.add(s);
            index = peskoOddlovae(dka, index);
      }
  }
    
    /**
    * Tato metoda pesko oddlovae v analyzovanm textu.
    * @param dka analyzovan dek;
    * @param od    index, od kterho se m zat
    * @return      index, kde zan nsledujc slovo, nebo -1, jsme-li na konci dku
    */
    private int peskoOddlovae(String dka, int od)
     {
        if(od >= dka.length()) return -1;          // Jsme-li na konci dku, vra -1
        while(oddlovae.indexOf(dka.charAt(od))>=0)
        {
            if(++od == dka.length()) return -1;
        }
        return od;
    }
    
    /**
    * Konstruktor, kter vytvo instanci
    * pracujc s kdovou strnkou danou parametrem;
    * @param kdovStrnka  etzec ve tvary "CpXXX", kde XXX je 
    * slo poadovan kodov strnky
    */    
    public Analyztor(String kdovStrnka)
    {
        kdovn = kdovStrnka;
    }
    
    /**
    * Konstruktor bez parametr vytvo instanci
    * pracujc s kdovou 852
    */
    public Analyztor()
    {}
} 