package slova2;

class Analyzátor
{
    private final java.util.ArrayList<Dvojice> slovník = new java.util.ArrayList<>();
    private final String oddělovače = " .,;!?";
    private String kódování = "Cp852";
    
    /**
    * Tato metoda zajišťuje běh programu
    */
    void běh() throws java.io.UnsupportedEncodingException 
    {
       java.util.Scanner vstup = new java.util.Scanner(System.in, kódování);
       java.io.OutputStreamWriter osw = new java.io.OutputStreamWriter(System.out, kódování);
       java.io.PrintWriter výstup = new java.io.PrintWriter(osw);

       while(vstup.hasNextLine())                 // Čti vstup
       {
           String řádka = vstup.nextLine();
           řádka = řádka.trim();                  // Odstraň okrajové mezery
           System.out.println(řádka);
           analyzujAUložVýsledky(řádka);
       }
       výstup.println(slovník);               // Vypiš výsledek
       výstup.close();
    }
    
    /**
    * Tato metoda rozloží řádku na slova
    * @param řádka analyzovaná řádka;
    * @param slovník   kontejner, do kterého budou ukládána slova
    */
    private void analyzujAUložVýsledky(String řádka)
    {
        if(řádka.equals(""))return;             // Prázdný řádek nás nezajímá
        int index = 0;                          // Index znaku v řádku
        StringBuffer slovo;                     // Sem uložíme získané slovo
        index = přeskočOddělovače(řádka, index);// Najdi začátek dalšího slova
        while(index >= 0)                       // Dokud nejsme na konci řádku
        {
            slovo = new StringBuffer("");
            // Přenes následující slovo do instance "slovo"
            while((index < řádka.length()) &&
                  (oddělovače.indexOf(řádka.charAt(index)) == -1))
            {
                slovo.append(řádka.charAt(index++));
            }
            // Ulož slovo do slovníku
            String s = new String(slovo);
            if(slovník.indexOf(s) == -1) přidej(s, slovník) ;
            index = přeskočOddělovače(řádka, index);
    }
  }
    
    /**
    * Tato metoda přeskočí oddělovače v analyzovaném textu.
    * @param řádka analyzovaný řádek;
    * @param od    index, od kterého se má začít
    * @return      index, kde začíná následující slovo, nebo -1, jsme-li na konci řádku
    */
    private int přeskočOddělovače(String řádka, int od)
     {
        if(od >= řádka.length()) return -1;          // Jsme-li na konci řádku, vrať -1
        while(oddělovače.indexOf(řádka.charAt(od))>=0)
        {
            if(++od == řádka.length()) return -1;
        }
        return od;
    }
    
    /**
    * Konstruktor, který vytvoří instanci
    * pracující s kódovou stránkou danou parametrem;
    * @param kódováStránka  řetězec ve tvary "CpXXX", kde XXX je 
    * číslo požadované kóodové stránky
    */    
    public Analyzátor(String kódováStránka)
    {
        kódování = kódováStránka;
    }
    
    /**
    * Konstruktor bez parametrů vytvoří instanci
    * pracující s kódovou 852
    */
    public Analyzátor()
    {}
    
    void přidej(String slovo, java.util.ArrayList<Dvojice> seznam)
    {
        Dvojice pár = new Dvojice(slovo);            // Vytvoř dvojici
        int index = seznam.indexOf(pár);             // Zkus ji najít v seznamu
        if(index < 0)                                // Když tam není
        {
            seznam.add(pár);                          // tak ji přidej
        }
        else                                          // jinak
        {
            pár = seznam.get(index);                  // si ji vyjmi a
            pár.dalšíVýskyt();                        // zvětši počet výskytů
        }
    }

} 