package konvertor;

public class Konvertor 
{
    private long základ;  // Základ číselné soustavy
    static String číslice = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"; // Řetězec obsahující všechny číslice, které se mohou vyskytnout v soustavách o základu od 2 do 36
    
    public String konverze(long n)
    {
        var výsledek = new StringBuffer(""); // Zde budeme vytvářet znakovou reprezentaci čísla
        boolean záporné = false;
        if(n==0)
        {                   // Je-li to nula, vrať řetězec "0" (je stejný ve všech soustavách)
            return "0";
        }
        if (n < 0)
        {
            záporné = true;
            n = -n;
        };
        while(n != 0)
        {
            výsledek.append(číslice.charAt((int)(n % základ)));
            n /= základ;
        }
        if(záporné)výsledek.append('-');
        return new String(výsledek.reverse());
    }

    public Konvertor(int báze) // Parametrem je základ soustavy
    { 
        if((báze < 2) || (báze > 36))
            throw new IllegalArgumentException("Základ mimo rozsah: " + báze);
        základ = báze;  
    }
}